#include "Rational.h"
#include <cassert>

Rational::Rational()
{
	num = 0;
	den = 1;
}

Rational::Rational(const Rational& original) : num(original.num),
den(original.den)  // initializer list
{
	// Nothing else to do
}

Rational::Rational(long int nm, long int dn)
{
	assert(dn);
	if(dn<0) {
		nm *= -1;
		dn *= -1;
	}
	num = nm;
	den = dn;
	reduce();
}

Rational::~Rational()
{
}

Rational& Rational::operator=(const Rational& rhs)
{
	num = rhs.num;
	den = rhs.den;
	return *this;
}

void Rational::reduce()
{
}

void Rational::insert(std::ostream& os) const
{
	os << num << '/' << den;
}

Rational Rational::operator+(const Rational& rhs) const
{
	Rational temp;
	temp.den = den*rhs.den;
	temp.num = num*rhs.den + rhs.num*den;
	temp.reduce();
	return temp;
}

Rational Rational::operator-(const Rational& rhs) const
{
	Rational temp(num*rhs.den-rhs.num*den, den*rhs.den);
	return temp;
}

// 5/7 + 1/3 = 22/21
const Rational& Rational::operator+=(const Rational& rhs)
{
	num = num*rhs.den + rhs.num*den;
	den = den*rhs.den;
	reduce();
	return *this;
}

std::ostream& operator<<(std::ostream& os, const Rational& rtnl)
{
	rtnl.insert(os);
	return os;
}







